<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `crates&#x2F;framework&#x2F;base&#x2F;icecap-runtime&#x2F;src&#x2F;tls.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>tls.rs - source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../storage.js"></script><script src="../../crates.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../icecap_runtime/index.html'><div class='logo-container rust-logo'><img src='../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1"> 1</span>
<span id="2"> 2</span>
<span id="3"> 3</span>
<span id="4"> 4</span>
<span id="5"> 5</span>
<span id="6"> 6</span>
<span id="7"> 7</span>
<span id="8"> 8</span>
<span id="9"> 9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">icecap_sel4::prelude</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident">icecap_sel4::sys</span>;

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::c</span>;

<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">TlsRegion</span> {
    <span class="ident">base</span>: <span class="ident">usize</span>,
    <span class="ident">tpidr</span>: <span class="ident">u64</span>,
}

<span class="kw">impl</span> <span class="ident">TlsRegion</span> {
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">align</span>() <span class="op">-</span><span class="op">&gt;</span> <span class="ident">usize</span> {
        <span class="kw">unsafe</span> { <span class="ident">c::icecap_runtime_tls_region_align</span> }
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">size</span>() <span class="op">-</span><span class="op">&gt;</span> <span class="ident">usize</span> {
        <span class="kw">unsafe</span> { <span class="ident">c::icecap_runtime_tls_region_size</span> }
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">num_small_pages</span>() <span class="op">-</span><span class="op">&gt;</span> <span class="ident">usize</span> {
        <span class="kw">let</span> <span class="ident">size</span> <span class="op">=</span> <span class="ident"><span class="self">Self</span>::align</span>() <span class="op">+</span> <span class="ident"><span class="self">Self</span>::size</span>(); <span class="comment">// HACK</span>
        <span class="kw">let</span> <span class="ident">frame_size</span> <span class="op">=</span> <span class="ident">FrameSize::Small</span>.<span class="ident">bytes</span>();
        <span class="ident">size</span> <span class="op">/</span> <span class="ident">frame_size</span> <span class="op">+</span> <span class="kw">if</span> <span class="ident">size</span> <span class="op">%</span> <span class="ident">frame_size</span> <span class="op">=</span><span class="op">=</span> <span class="number">0</span> { <span class="number">0</span> } <span class="kw">else</span> { <span class="number">1</span> }
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">offset_into_first_page</span>() <span class="op">-</span><span class="op">&gt;</span> <span class="ident">usize</span> {
        <span class="ident"><span class="self">Self</span>::align</span>()
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">init</span>(<span class="ident">base</span>: <span class="ident">usize</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="self">Self</span> {
        <span class="self">Self</span> {
            <span class="ident">base</span>,
            <span class="ident">tpidr</span>: <span class="kw">unsafe</span> { <span class="ident">c::icecap_runtime_tls_region_init</span>(<span class="ident">base</span>) },
        }
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">insert_ipc_buffer</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">ipc_buffer</span>: <span class="ident">usize</span>) {
        <span class="kw">unsafe</span> { <span class="ident">c::icecap_runtime_tls_region_insert_ipc_buffer</span>(<span class="self">self</span>.<span class="ident">base</span>, <span class="ident">ipc_buffer</span>) }
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">insert_tcb</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">tcb</span>: <span class="ident">sys::seL4_CPtr</span>) {
        <span class="kw">unsafe</span> { <span class="ident">c::icecap_runtime_tls_region_insert_tcb</span>(<span class="self">self</span>.<span class="ident">base</span>, <span class="ident">tcb</span>) }
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">tpidr</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">u64</span> {
        <span class="self">self</span>.<span class="ident">tpidr</span>
    }
}
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../" data-current-crate="icecap_runtime" data-search-index-js="../../search-index.js" data-search-js="../../search.js"></div>
    <script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script>
</body></html>